{ +--------------------------------------------------------------------------+ }
{ | Trafo v0.9 * Mains transformer calculating programme                     | }
{ | Copyright (C) 1996-2010 Pozsar Zsolt <pozsarzs@t-email.hu>               | }
{ | frmabout.pp                                                              | }
{ | About form                                                               | }
{ +--------------------------------------------------------------------------+ }

{
  This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

  This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

  You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit frmabout;
{$mode objfpc}{$H+}
interface
uses
  Classes, SysUtils, process, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Buttons;
type
  { TForm2 }
  TForm2 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Bevel1: TBevel;
    Button1: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Process1: TProcess;
    Process2: TProcess;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure Label8Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;
var
  Form2: TForm2;
  offline: boolean;

Resourcestring
  MESSAGE01 = 'About';
  MESSAGE02 = 'Mains transformer calculator programme';
  MESSAGE03 = 'Licence: GNU GPL 3.0 or later';
  MESSAGE04 = 'Web';
  MESSAGE05 = 'E-mail';
  MESSAGE06 = 'Cannot run default browser.';
  MESSAGE07 = 'Cannot run default mailer.';
  MESSAGE08 = '&Close';

procedure runbrowser(url: string);

implementation

//-- run browser ---------------------------------------------------------------
procedure runbrowser(url: string);
const
  {$IFDEF LINUX}
    defbrowser='xdg-open';
  {$ENDIF}
  {$IFDEF WINDOWS}
    defbrowser='rundll32.exe url.dll,FileProtocolHandler';
  {$ENDIF}
begin
  Form2.Process1.CommandLine:=defbrowser+' '+url;
  try
    if offline=false then Form2.Process1.Execute;
  except
    ShowMessage(MESSAGE06);
  end;
end;

//-- run mailer ----------------------------------------------------------------
procedure runmailer(url: string);
const
  {$IFDEF LINUX}
    defmailer='xdg-email';
  {$ENDIF}
  {$IFDEF WINDOWS}
    defmailer='rundll32.exe url.dll,FileProtocolHandler mailto:';
  {$ENDIF}
begin
  Form2.Process2.CommandLine:=defmailer+' '+url;
  try
    if offline=false then Form2.Process2.Execute;
  except
    ShowMessage(MESSAGE07);
  end;
end;

//-- close about --------------------------------------------------------------
procedure TForm2.Button1Click(Sender: TObject);
begin
  Form2.Close;
end;

//-- open default browser ------------------------------------------------------
procedure TForm2.Label7Click(Sender: TObject);
begin
  runbrowser(Label7.Caption);
end;

//-- open default mailer -------------------------------------------------------
procedure TForm2.Label8Click(Sender: TObject);
begin
  runmailer(Label8.Caption);
end;

//-- OnCreate event ------------------------------------------------------------
procedure TForm2.FormCreate(Sender: TObject);
begin
  Form2.Caption := MESSAGE01;
  Button1.Caption := MESSAGE08;
  Label4.Caption := MESSAGE05+':';
  Label3.Caption := MESSAGE04+':';
  Label5.Caption := MESSAGE02;
  Label6.Caption := MESSAGE03;
end;

initialization
  {$I frmabout.lrs}
end.
